<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="vipPriceList" @selection-change="handleSelectionChange">
      <el-table-column label="会员类型" align="center" prop="vipType">
        <template v-slot="scope">
          <cai-dict-tag :options="vipTypeList" :value="scope.row.vipType"/>
        </template>
      </el-table-column>
      <el-table-column label="会员时间" align="center" prop="vipTime">
        <template v-slot="scope">
          <cai-dict-tag :options="vipTimeList" :value="scope.row.vipTime"/>
        </template>
      </el-table-column>
      <el-table-column label="会员价格" align="center" prop="vipPrice"/>
      <el-table-column label="状态" align="center" prop="enableStatus">
        <template v-slot="scope">
          <el-switch
              v-model="scope.row.enableStatus"
              :active-value="1"
              :inactive-value="0"
              @change="handleEnableStatusChange(scope.row)"
          ></el-switch>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template v-slot="scope">
          <el-button
              size="mini"
              type="text"
              icon="el-icon-edit"
              @click="handleUpdate(scope.row)"
              v-hasPermi="['xq:vipPrice:edit']"
          >修改价格
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
        v-show="total>0"
        :total="total"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getList"
    />

    <vip-price-update-dialog v-if="vipPriceUpdateDialogVisible" ref="vipPriceUpdateDialog" @refreshDataList="getList" />
  </div>
</template>

<script>
import { listVipPrice, updateVipPrice } from '@/api/xq/vipPrice'
import { vipTimeList, vipTypeList } from '@/constant/statusMap'
import VipPriceUpdateDialog from '@/views/xq/vipPrice/vip-price-update-dialog.vue'
export default {
  name: 'VipPrice',
  components: {VipPriceUpdateDialog},
  data() {
    return {
      vipTypeList,vipTimeList,
      vipPriceUpdateDialogVisible: false,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 会员价格设置表格数据
      vipPriceList: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10
      }
    }
  },
  created() {
    this.getList()
  },
  methods: {
    /** 查询会员价格设置列表 */
    getList() {
      this.loading = true
      listVipPrice(this.queryParams).then(response => {
        this.vipPriceList = response.rows
        this.total = response.total
        this.loading = false
      })
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm('queryForm')
      this.handleQuery()
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    handleUpdate(row) {
      this.vipPriceUpdateDialogVisible = true
      this.$nextTick(() => {
        this.$refs.vipPriceUpdateDialog.init(row.id)
      })
    },
    /** 修改按钮操作 */
    handleEnableStatusChange(row) {
      let text = row.enableStatus === 1 ? '开启' : '取消'
      this.$confirm('确认要' + text + '会员设置数据吗?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        return updateVipPrice({ id: row.id, enableStatus: row.enableStatus })
      }).then(() => {
        this.$modal.msgSuccess(text + '成功')
      }).catch(function() {
        row.enableStatus = row.enableStatus === 1 ? 0 : 1
      })
    }
  }
}
</script>
